<script lang="ts">
	import { preventDefault } from 'svelte/legacy';

	import { enhance } from '$app/forms'
	import ProfileHeader from '../../components/ProfileHeader.svelte'
	import TextEntry from '../../components/TextEntry.svelte'
	import ColourSelect from '../../components/ColourSelect.svelte'
	import type { PageData } from './$types'
	import { startRegistration } from '@simplewebauthn/browser'
	import Popup from '../../components/Popup.svelte'
	import { submit } from '../../manualFormEnhancement'
	import type { ActionResult } from '@sveltejs/kit'
	import { invalidateAll } from '$app/navigation'
	import { tick } from 'svelte'

	interface Props {
		data: PageData;
	}

	let { data }: Props = $props();

	let inputName: string = $state(data.user.name)
	let inputEmail: string = data.user?.authId
	let inputAccent: string = $state(data.user?.accentColour)
	let fidoStatus: string = $state('')

	let profileForm: HTMLFormElement = $state()

	const donger1 = '⮦( ಠ‿ಠ)⮥'
	const donger2 = '⮤(ಠ‿ಠ )⮧'
	let donger = $state(donger1)

	function danceyBoi() {
		let speed = 750
		let inner: NodeJS.Timer
		setIntervalAndExecute(() => {
			if (inner) {
				speed = speed > 50 ? speed - 50 : speed
				clearInterval(inner)
			}

			inner = setInterval(() => {
				if (donger === donger1) {
					donger = donger2
				} else {
					donger = donger1
				}
			}, speed)
		}, 60 * 1000)
	}

	function setIntervalAndExecute(fn: () => any, ms: number) {
		fn()
		setInterval(fn, ms)
	}

	danceyBoi()

	function logout() {}

	async function fidoCallback(json: { result: Record<string, any> }) {
		const result = json.result
		const { url } = result.data

		try {
			const registration = await startRegistration(result.data.opts)

			const res = await fetch(url, {
				method: 'POST',
				body: JSON.stringify({ ...registration, intent: 'register', username: data.user!.authId }),
				headers: {
					accept: 'application/json',
					'Content-Type': 'application/json'
				}
			})
			if (res.status !== 200) {
				const body = await res.json()
				return
			}
			fidoStatus = "Success! You'll now be able to log in using this fingerprint on this device in the future"
			setTimeout(() => {
				fidoStatus = ''
			}, 5000)
		} catch (e: any) {
			if (e.message?.includes('previously registered')) {
				fidoStatus = 'This fingerprint is already registered!'
			} else {
				fidoStatus = 'Something went wrong: ' + e.message
			}
			setTimeout(() => {
				fidoStatus = ''
			}, 5000)
		}
	}

	async function handleProfileSubmit() {
		const result: ActionResult = await submit(profileForm)

		if (result.type === 'success') {
			// re-run all `load` functions, following the successful update
			data.user!.name = result.data!.name
			data.user!.accentColour = result.data!.accentColour
			document.getElementById('body')!.style.accentColor = result.data!.accentColour
			await invalidateAll()
		}
	}
</script>

<div class="page">
	<div class="profile">
		<ProfileHeader avatar={data.user?.avatar} avatarSize={'25vw'} name={data.user?.name} email={data.user?.authId} />
	</div>
	<form method="POST" action="?/update" bind:this={profileForm} onsubmit={preventDefault(handleProfileSubmit)}>
		<TextEntry title="Username" type="text" bind:value={inputName} on:focusout={(e) => profileForm.requestSubmit()} />

		<ColourSelect
			title="Theme Colour"
			description="Change the background colour of buttons and other elements in app"
			items={['#ff6961', '#ffb480', '#f8f38d', '#42d6a4', '#36b37e', '#08cad1', '#59adf6', '#9d94ff', '#c780e8']}
			bind:value={inputAccent}
			on:click={(e) =>
				setTimeout(() => {
					profileForm.requestSubmit()
				}, 10)}
		/>

		<button>Save Profile</button>
	</form>

	<div class="flex">
		<form method="POST" action="?/logout" use:enhance={logout}>
			<button>Logout</button>
		</form>

		<form method="POST" action="?/delete">
			<button>Delete existing route data</button>
		</form>

		<form method="POST" action="?/fitbit">
			<button>{data.user?.fitbitAuth?.length ? 'Reconnect' : 'Connect'} Fitbit</button>
		</form>

		<form method="POST" action="?/fido" use:enhance={() => fidoCallback}>
			<button>Register a Fingerprint</button>
		</form>

		<form method="POST">
			<button>Delete Account (TODO)</button>
		</form>
	</div>

	<h1 style="font-size: 30vw">W.I.P</h1>
	<h1>{donger}</h1>

	{#if fidoStatus}
		<Popup text={fidoStatus} />
	{/if}
</div>

<style>
	button {
		background-color: var(--accentColour);
		border: none;
		border-radius: 0.25rem;
		display: inline-block;
		margin: 1rem;
		font-family: Quicksand;
		font-weight: 400;
		padding-left: 1rem;
		padding-right: 1rem;
		padding-top: 0.5rem;
		padding-bottom: 0.5rem;
		font-size: 1.5rem;
	}

	.page {
		margin-top: 1rem;
	}

	.profile {
		padding-bottom: 2rem;
	}

	.flex form {
		display: inline-block;
	}

	h1 {
		--color-background: #1b1b1b;
		--stroke-width: calc(1em / 16);
		--font-size: 15vw;
		--font-weight: 700;
		--letter-spacing: calc(1em / 8);

		-webkit-background-clip: text;
		background-clip: text;
		background-image: -webkit-gradient(
			linear,
			left top,
			right top,
			from(#09f1b8),
			color-stop(#00a2ff),
			color-stop(#ff00d2),
			to(#fed90f)
		);
		background-image: -o-linear-gradient(left, #09f1b8, #00a2ff, #ff00d2, #fed90f);
		background-image: linear-gradient(to right, #09f1b8, #00a2ff, #ff00d2, #fed90f);
		color: #000119;
		color: var(--color-background);
		font-size: 30vmin;
		font-size: var(--font-size);
		font-weight: 700;
		font-weight: var(--font-weight);
		letter-spacing: calc(1em / 8);
		letter-spacing: var(--letter-spacing);
		padding: calc(--stroke-width / 2);
		-webkit-text-stroke-color: transparent;
		-webkit-text-stroke-width: calc(1em / 16);
		-webkit-text-stroke-width: var(--stroke-width);
	}
</style>
